diff -crN linux-3.8.6-gentoo/drivers/hv/hv_snapshot.c linux-3.8.6-gentoo-hyperv/drivers/hv/hv_snapshot.c
*** linux-3.8.6-gentoo/drivers/hv/hv_snapshot.c	Thu Jan  1 09:00:00 1970
--- linux-3.8.6-gentoo-hyperv/drivers/hv/hv_snapshot.c	Sat Apr 13 02:24:31 2013
***************
*** 0 ****
--- 1,287 ----
+ /*
+  * An implementation of host initiated guest snapshot.
+  *
+  *
+  * Copyright (C) 2013, Microsoft, Inc.
+  * Author : K. Y. Srinivasan <kys@microsoft.com>
+  *
+  * This program is free software; you can redistribute it and/or modify it
+  * under the terms of the GNU General Public License version 2 as published
+  * by the Free Software Foundation.
+  *
+  * This program is distributed in the hope that it will be useful, but
+  * WITHOUT ANY WARRANTY; without even the implied warranty of
+  * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE, GOOD TITLE or
+  * NON INFRINGEMENT.  See the GNU General Public License for more
+  * details.
+  *
+  */
+ #define pr_fmt(fmt) KBUILD_MODNAME ": " fmt
+ 
+ #include <linux/net.h>
+ #include <linux/nls.h>
+ #include <linux/connector.h>
+ #include <linux/workqueue.h>
+ #include <linux/hyperv.h>
+ 
+ 
+ 
+ /*
+  * Global state maintained for transaction that is being processed.
+  * Note that only one transaction can be active at any point in time.
+  *
+  * This state is set when we receive a request from the host; we
+  * cleanup this state when the transaction is completed - when we respond
+  * to the host with the key value.
+  */
+ 
+ static struct {
+ 	bool active; /* transaction status - active or not */
+ 	int recv_len; /* number of bytes received. */
+ 	struct vmbus_channel *recv_channel; /* chn we got the request */
+ 	u64 recv_req_id; /* request ID. */
+ 	struct hv_vss_msg  *msg; /* current message */
+ } vss_transaction;
+ 
+ 
+ static void vss_respond_to_host(int error);
+ 
+ static struct cb_id vss_id = { CN_VSS_IDX, CN_VSS_VAL };
+ static const char vss_name[] = "vss_kernel_module";
+ static __u8 *recv_buffer;
+ 
+ static void vss_send_op(struct work_struct *dummy);
+ static DECLARE_WORK(vss_send_op_work, vss_send_op);
+ 
+ /*
+  * Callback when data is received from user mode.
+  */
+ 
+ static void
+ vss_cn_callback(struct cn_msg *msg, struct netlink_skb_parms *nsp)
+ {
+ 	struct hv_vss_msg *vss_msg;
+ 
+ 	vss_msg = (struct hv_vss_msg *)msg->data;
+ 
+ 	if (vss_msg->vss_hdr.operation == VSS_OP_REGISTER) {
+ 		pr_info("VSS daemon registered\n");
+ 		vss_transaction.active = false;
+ 		if (vss_transaction.recv_channel != NULL)
+ 			hv_vss_onchannelcallback(vss_transaction.recv_channel);
+ 		return;
+ 
+ 	}
+ 	vss_respond_to_host(vss_msg->error);
+ }
+ 
+ 
+ static void vss_send_op(struct work_struct *dummy)
+ {
+ 	int op = vss_transaction.msg->vss_hdr.operation;
+ 	struct cn_msg *msg;
+ 	struct hv_vss_msg *vss_msg;
+ 
+ 	msg = kzalloc(sizeof(*msg) + sizeof(*vss_msg), GFP_ATOMIC);
+ 	if (!msg)
+ 		return;
+ 
+ 	vss_msg = (struct hv_vss_msg *)msg->data;
+ 
+ 	msg->id.idx =  CN_VSS_IDX;
+ 	msg->id.val = CN_VSS_VAL;
+ 
+ 	vss_msg->vss_hdr.operation = op;
+ 	msg->len = sizeof(struct hv_vss_msg);
+ 
+ 	cn_netlink_send(msg, 0, GFP_ATOMIC);
+ 	kfree(msg);
+ 
+ 	return;
+ }
+ 
+ /*
+  * Send a response back to the host.
+  */
+ 
+ static void
+ vss_respond_to_host(int error)
+ {
+ 	struct icmsg_hdr *icmsghdrp;
+ 	u32	buf_len;
+ 	struct vmbus_channel *channel;
+ 	u64	req_id;
+ 
+ 	/*
+ 	 * If a transaction is not active; log and return.
+ 	 */
+ 
+ 	if (!vss_transaction.active) {
+ 		/*
+ 		 * This is a spurious call!
+ 		 */
+ 		pr_warn("VSS: Transaction not active\n");
+ 		return;
+ 	}
+ 	/*
+ 	 * Copy the global state for completing the transaction. Note that
+ 	 * only one transaction can be active at a time.
+ 	 */
+ 
+ 	buf_len = vss_transaction.recv_len;
+ 	channel = vss_transaction.recv_channel;
+ 	req_id = vss_transaction.recv_req_id;
+ 	vss_transaction.active = false;
+ 
+ 	icmsghdrp = (struct icmsg_hdr *)
+ 			&recv_buffer[sizeof(struct vmbuspipe_hdr)];
+ 
+ 	if (channel->onchannel_callback == NULL)
+ 		/*
+ 		 * We have raced with util driver being unloaded;
+ 		 * silently return.
+ 		 */
+ 		return;
+ 
+ 	icmsghdrp->status = error;
+ 
+ 	icmsghdrp->icflags = ICMSGHDRFLAG_TRANSACTION | ICMSGHDRFLAG_RESPONSE;
+ 
+ 	vmbus_sendpacket(channel, recv_buffer, buf_len, req_id,
+ 				VM_PKT_DATA_INBAND, 0);
+ 
+ }
+ 
+ /*
+  * This callback is invoked when we get a VSS message from the host.
+  * The host ensures that only one VSS transaction can be active at a time.
+  */
+ 
+ void hv_vss_onchannelcallback(void *context)
+ {
+ 	struct vmbus_channel *channel = context;
+ 	u32 recvlen;
+ 	u64 requestid;
+ 	struct hv_vss_msg *vss_msg;
+ 
+ 
+ 	struct icmsg_hdr *icmsghdrp;
+ 	struct icmsg_negotiate *negop = NULL;
+ 
+ 	if (vss_transaction.active) {
+ 		/*
+ 		 * We will defer processing this callback once
+ 		 * the current transaction is complete.
+ 		 */
+ 		vss_transaction.recv_channel = channel;
+ 		return;
+ 	}
+ 
+ 	vmbus_recvpacket(channel, recv_buffer, PAGE_SIZE * 2, &recvlen,
+ 			 &requestid);
+ 
+ 	if (recvlen > 0) {
+ 		icmsghdrp = (struct icmsg_hdr *)&recv_buffer[
+ 			sizeof(struct vmbuspipe_hdr)];
+ 
+ 		if (icmsghdrp->icmsgtype == ICMSGTYPE_NEGOTIATE) {
+ 			vmbus_prep_negotiate_resp(icmsghdrp, negop,
+ 				 recv_buffer, MAX_SRV_VER, MAX_SRV_VER);
+ 			/*
+ 			 * We currently negotiate the highest number the
+ 			 * host has presented. If this version is not
+ 			 * atleast 5.0, reject.
+ 			 */
+ 			negop = (struct icmsg_negotiate *)&recv_buffer[
+ 				sizeof(struct vmbuspipe_hdr) +
+ 				sizeof(struct icmsg_hdr)];
+ 
+ 			if (negop->icversion_data[1].major < 5)
+ 				negop->icframe_vercnt = 0;
+ 		} else {
+ 			vss_msg = (struct hv_vss_msg *)&recv_buffer[
+ 				sizeof(struct vmbuspipe_hdr) +
+ 				sizeof(struct icmsg_hdr)];
+ 
+ 			/*
+ 			 * Stash away this global state for completing the
+ 			 * transaction; note transactions are serialized.
+ 			 */
+ 
+ 			vss_transaction.recv_len = recvlen;
+ 			vss_transaction.recv_channel = channel;
+ 			vss_transaction.recv_req_id = requestid;
+ 			vss_transaction.active = true;
+ 			vss_transaction.msg = (struct hv_vss_msg *)vss_msg;
+ 
+ 			switch (vss_msg->vss_hdr.operation) {
+ 				/*
+ 				 * Initiate a "freeze/thaw"
+ 				 * operation in the guest.
+ 				 * We respond to the host once
+ 				 * the operation is complete.
+ 				 *
+ 				 * We send the message to the
+ 				 * user space daemon and the
+ 				 * operation is performed in
+ 				 * the daemon.
+ 				 */
+ 			case VSS_OP_FREEZE:
+ 			case VSS_OP_THAW:
+ 				schedule_work(&vss_send_op_work);
+ 				return;
+ 
+ 			case VSS_OP_HOT_BACKUP:
+ 				vss_msg->vss_cf.flags =
+ 					 VSS_HBU_NO_AUTO_RECOVERY;
+ 				vss_respond_to_host(0);
+ 				return;
+ 
+ 			case VSS_OP_GET_DM_INFO:
+ 				vss_msg->dm_info.flags = 0;
+ 				vss_respond_to_host(0);
+ 				return;
+ 
+ 			default:
+ 				vss_respond_to_host(0);
+ 				return;
+ 
+ 			}
+ 
+ 		}
+ 
+ 		icmsghdrp->icflags = ICMSGHDRFLAG_TRANSACTION
+ 			| ICMSGHDRFLAG_RESPONSE;
+ 
+ 		vmbus_sendpacket(channel, recv_buffer,
+ 				       recvlen, requestid,
+ 				       VM_PKT_DATA_INBAND, 0);
+ 	}
+ 
+ }
+ 
+ int
+ hv_vss_init(struct hv_util_service *srv)
+ {
+ 	int err;
+ 
+ 	err = cn_add_callback(&vss_id, vss_name, vss_cn_callback);
+ 	if (err)
+ 		return err;
+ 	recv_buffer = srv->recv_buffer;
+ 
+ 	/*
+ 	 * When this driver loads, the user level daemon that
+ 	 * processes the host requests may not yet be running.
+ 	 * Defer processing channel callbacks until the daemon
+ 	 * has registered.
+ 	 */
+ 	vss_transaction.active = true;
+ 	return 0;
+ }
+ 
+ void hv_vss_deinit(void)
+ {
+ 	cn_del_callback(&vss_id);
+ 	cancel_work_sync(&vss_send_op_work);
+ }
diff -crN linux-3.8.6-gentoo/drivers/hv/hv_util.c linux-3.8.6-gentoo-hyperv/drivers/hv/hv_util.c
*** linux-3.8.6-gentoo/drivers/hv/hv_util.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/hv_util.c	Sat Apr 13 02:24:31 2013
***************
*** 49,54 ****
--- 49,70 ----
  	.util_deinit = hv_kvp_deinit,
  };
  
+ static struct hv_util_service util_vss = {
+ 	.util_cb = hv_vss_onchannelcallback,
+ 	.util_init = hv_vss_init,
+ 	.util_deinit = hv_vss_deinit,
+ };
+ 
+ static void perform_shutdown(struct work_struct *dummy)
+ {
+ 	orderly_poweroff(true);
+ }
+ 
+ /*
+  * Perform the shutdown operation in a thread context.
+  */
+ static DECLARE_WORK(shutdown_work, perform_shutdown);
+ 
  static void shutdown_onchannelcallback(void *context)
  {
  	struct vmbus_channel *channel = context;
***************
*** 106,112 ****
  	}
  
  	if (execute_shutdown == true)
! 		orderly_poweroff(true);
  }
  
  /*
--- 122,128 ----
  	}
  
  	if (execute_shutdown == true)
! 		schedule_work(&shutdown_work);
  }
  
  /*
***************
*** 274,279 ****
--- 290,305 ----
  		}
  	}
  
+ 	/*
+ 	 * The set of services managed by the util driver are not performance
+ 	 * critical and do not need batched reading. Furthermore, some services
+ 	 * such as KVP can only handle one message from the host at a time.
+ 	 * Turn off batched reading for all util drivers before we open the
+ 	 * channel.
+ 	 */
+ 
+ 	set_channel_read_state(dev->channel, false);
+ 
  	ret = vmbus_open(dev->channel, 4 * PAGE_SIZE, 4 * PAGE_SIZE, NULL, 0,
  			srv->util_cb, dev->channel);
  	if (ret)
***************
*** 304,324 ****
  
  static const struct hv_vmbus_device_id id_table[] = {
  	/* Shutdown guid */
! 	{ VMBUS_DEVICE(0x31, 0x60, 0x0B, 0X0E, 0x13, 0x52, 0x34, 0x49,
! 		       0x81, 0x8B, 0x38, 0XD9, 0x0C, 0xED, 0x39, 0xDB)
! 	  .driver_data = (unsigned long)&util_shutdown },
  	/* Time synch guid */
! 	{ VMBUS_DEVICE(0x30, 0xe6, 0x27, 0x95, 0xae, 0xd0, 0x7b, 0x49,
! 		       0xad, 0xce, 0xe8, 0x0a, 0xb0, 0x17, 0x5c, 0xaf)
! 	  .driver_data = (unsigned long)&util_timesynch },
  	/* Heartbeat guid */
! 	{ VMBUS_DEVICE(0x39, 0x4f, 0x16, 0x57, 0x15, 0x91, 0x78, 0x4e,
! 		       0xab, 0x55, 0x38, 0x2f, 0x3b, 0xd5, 0x42, 0x2d)
! 	  .driver_data = (unsigned long)&util_heartbeat },
  	/* KVP guid */
! 	{ VMBUS_DEVICE(0xe7, 0xf4, 0xa0, 0xa9, 0x45, 0x5a, 0x96, 0x4d,
! 		       0xb8, 0x27, 0x8a, 0x84, 0x1e, 0x8c, 0x3,  0xe6)
! 	  .driver_data = (unsigned long)&util_kvp },
  	{ },
  };
  
--- 330,354 ----
  
  static const struct hv_vmbus_device_id id_table[] = {
  	/* Shutdown guid */
! 	{ HV_SHUTDOWN_GUID,
! 	  .driver_data = (unsigned long)&util_shutdown
! 	},
  	/* Time synch guid */
! 	{ HV_TS_GUID,
! 	  .driver_data = (unsigned long)&util_timesynch
! 	},
  	/* Heartbeat guid */
! 	{ HV_HEART_BEAT_GUID,
! 	  .driver_data = (unsigned long)&util_heartbeat
! 	},
  	/* KVP guid */
! 	{ HV_KVP_GUID,
! 	  .driver_data = (unsigned long)&util_kvp
! 	},
! 	/* VSS GUID */
! 	{ HV_VSS_GUID,
! 	  .driver_data = (unsigned long)&util_vss
! 	},
  	{ },
  };
  
diff -crN linux-3.8.6-gentoo/drivers/hv/hyperv_vmbus.h linux-3.8.6-gentoo-hyperv/drivers/hv/hyperv_vmbus.h
*** linux-3.8.6-gentoo/drivers/hv/hyperv_vmbus.h	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/hyperv_vmbus.h	Sat Apr 13 02:25:04 2013
***************
*** 101,115 ****
  /* Define invalid partition identifier. */
  #define HV_PARTITION_ID_INVALID		((u64)0x0)
  
- /* Define connection identifier type. */
- union hv_connection_id {
- 	u32 asu32;
- 	struct {
- 		u32 id:24;
- 		u32 reserved:8;
- 	} u;
- };
- 
  /* Define port identifier type. */
  union hv_port_id {
  	u32 asu32;
--- 101,106 ----
***************
*** 338,350 ****
  	u64 payload[HV_MESSAGE_PAYLOAD_QWORD_COUNT];
  };
  
- /* Definition of the hv_signal_event hypercall input structure. */
- struct hv_input_signal_event {
- 	union hv_connection_id connectionid;
- 	u16 flag_number;
- 	u16 rsvdz;
- };
- 
  /*
   * Versioning definitions used for guests reporting themselves to the
   * hypervisor, and visa versa.
--- 329,334 ----
***************
*** 498,508 ****
  
  
  
- struct hv_input_signal_event_buffer {
- 	u64 align8;
- 	struct hv_input_signal_event event;
- };
- 
  struct hv_context {
  	/* We only support running on top of Hyper-V
  	* So at this point this really can only contain the Hyper-V ID
--- 482,487 ----
***************
*** 513,528 ****
  
  	bool synic_initialized;
  
- 	/*
- 	 * This is used as an input param to HvCallSignalEvent hypercall. The
- 	 * input param is immutable in our usage and must be dynamic mem (vs
- 	 * stack or global). */
- 	struct hv_input_signal_event_buffer *signal_event_buffer;
- 	/* 8-bytes aligned of the buffer above */
- 	struct hv_input_signal_event *signal_event_param;
- 
  	void *synic_message_page[NR_CPUS];
  	void *synic_event_page[NR_CPUS];
  };
  
  extern struct hv_context hv_context;
--- 492,515 ----
  
  	bool synic_initialized;
  
  	void *synic_message_page[NR_CPUS];
  	void *synic_event_page[NR_CPUS];
+ 	/*
+ 	 * Hypervisor's notion of virtual processor ID is different from
+ 	 * Linux' notion of CPU ID. This information can only be retrieved
+ 	 * in the context of the calling CPU. Setup a map for easy access
+ 	 * to this information:
+ 	 *
+ 	 * vp_index[a] is the Hyper-V's processor ID corresponding to
+ 	 * Linux cpuid 'a'.
+ 	 */
+ 	u32 vp_index[NR_CPUS];
+ 	/*
+ 	 * Starting with win8, we can take channel interrupts on any CPU;
+ 	 * we will manage the tasklet that handles events on a per CPU
+ 	 * basis.
+ 	 */
+ 	struct tasklet_struct *event_dpc[NR_CPUS];
  };
  
  extern struct hv_context hv_context;
***************
*** 538,549 ****
  			 enum hv_message_type message_type,
  			 void *payload, size_t payload_size);
  
! extern u16 hv_signal_event(void);
  
  extern void hv_synic_init(void *irqarg);
  
  extern void hv_synic_cleanup(void *arg);
  
  
  /* Interface */
  
--- 525,543 ----
  			 enum hv_message_type message_type,
  			 void *payload, size_t payload_size);
  
! extern u16 hv_signal_event(void *con_id);
  
  extern void hv_synic_init(void *irqarg);
  
  extern void hv_synic_cleanup(void *arg);
  
+ /*
+  * Host version information.
+  */
+ extern unsigned int host_info_eax;
+ extern unsigned int host_info_ebx;
+ extern unsigned int host_info_ecx;
+ extern unsigned int host_info_edx;
  
  /* Interface */
  
***************
*** 555,561 ****
  
  int hv_ringbuffer_write(struct hv_ring_buffer_info *ring_info,
  		    struct scatterlist *sglist,
! 		    u32 sgcount);
  
  int hv_ringbuffer_peek(struct hv_ring_buffer_info *ring_info, void *buffer,
  		   u32 buflen);
--- 549,555 ----
  
  int hv_ringbuffer_write(struct hv_ring_buffer_info *ring_info,
  		    struct scatterlist *sglist,
! 		    u32 sgcount, bool *signal);
  
  int hv_ringbuffer_peek(struct hv_ring_buffer_info *ring_info, void *buffer,
  		   u32 buflen);
***************
*** 563,575 ****
  int hv_ringbuffer_read(struct hv_ring_buffer_info *ring_info,
  		   void *buffer,
  		   u32 buflen,
! 		   u32 offset);
  
- u32 hv_get_ringbuffer_interrupt_mask(struct hv_ring_buffer_info *ring_info);
  
  void hv_ringbuffer_get_debuginfo(struct hv_ring_buffer_info *ring_info,
  			    struct hv_ring_buffer_debug_info *debug_info);
  
  /*
   * Maximum channels is determined by the size of the interrupt page
   * which is PAGE_SIZE. 1/2 of PAGE_SIZE is for send endpoint interrupt
--- 557,572 ----
  int hv_ringbuffer_read(struct hv_ring_buffer_info *ring_info,
  		   void *buffer,
  		   u32 buflen,
! 		   u32 offset, bool *signal);
  
  
  void hv_ringbuffer_get_debuginfo(struct hv_ring_buffer_info *ring_info,
  			    struct hv_ring_buffer_debug_info *debug_info);
  
+ void hv_begin_read(struct hv_ring_buffer_info *rbi);
+ 
+ u32 hv_end_read(struct hv_ring_buffer_info *rbi);
+ 
  /*
   * Maximum channels is determined by the size of the interrupt page
   * which is PAGE_SIZE. 1/2 of PAGE_SIZE is for send endpoint interrupt
***************
*** 657,663 ****
  
  int vmbus_post_msg(void *buffer, size_t buflen);
  
! int vmbus_set_event(u32 child_relid);
  
  void vmbus_on_event(unsigned long data);
  
--- 654,660 ----
  
  int vmbus_post_msg(void *buffer, size_t buflen);
  
! int vmbus_set_event(struct vmbus_channel *channel);
  
  void vmbus_on_event(unsigned long data);
  
diff -crN linux-3.8.6-gentoo/drivers/hv/ring_buffer.c linux-3.8.6-gentoo-hyperv/drivers/hv/ring_buffer.c
*** linux-3.8.6-gentoo/drivers/hv/ring_buffer.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/ring_buffer.c	Sat Apr 13 02:24:31 2013
***************
*** 29,34 ****
--- 29,134 ----
  
  #include "hyperv_vmbus.h"
  
+ void hv_begin_read(struct hv_ring_buffer_info *rbi)
+ {
+ 	rbi->ring_buffer->interrupt_mask = 1;
+ 	smp_mb();
+ }
+ 
+ u32 hv_end_read(struct hv_ring_buffer_info *rbi)
+ {
+ 	u32 read;
+ 	u32 write;
+ 
+ 	rbi->ring_buffer->interrupt_mask = 0;
+ 	smp_mb();
+ 
+ 	/*
+ 	 * Now check to see if the ring buffer is still empty.
+ 	 * If it is not, we raced and we need to process new
+ 	 * incoming messages.
+ 	 */
+ 	hv_get_ringbuffer_availbytes(rbi, &read, &write);
+ 
+ 	return read;
+ }
+ 
+ /*
+  * When we write to the ring buffer, check if the host needs to
+  * be signaled. Here is the details of this protocol:
+  *
+  *	1. The host guarantees that while it is draining the
+  *	   ring buffer, it will set the interrupt_mask to
+  *	   indicate it does not need to be interrupted when
+  *	   new data is placed.
+  *
+  *	2. The host guarantees that it will completely drain
+  *	   the ring buffer before exiting the read loop. Further,
+  *	   once the ring buffer is empty, it will clear the
+  *	   interrupt_mask and re-check to see if new data has
+  *	   arrived.
+  */
+ 
+ static bool hv_need_to_signal(u32 old_write, struct hv_ring_buffer_info *rbi)
+ {
+ 	smp_mb();
+ 	if (rbi->ring_buffer->interrupt_mask)
+ 		return false;
+ 
+ 	/*
+ 	 * This is the only case we need to signal when the
+ 	 * ring transitions from being empty to non-empty.
+ 	 */
+ 	if (old_write == rbi->ring_buffer->read_index)
+ 		return true;
+ 
+ 	return false;
+ }
+ 
+ /*
+  * To optimize the flow management on the send-side,
+  * when the sender is blocked because of lack of
+  * sufficient space in the ring buffer, potential the
+  * consumer of the ring buffer can signal the producer.
+  * This is controlled by the following parameters:
+  *
+  * 1. pending_send_sz: This is the size in bytes that the
+  *    producer is trying to send.
+  * 2. The feature bit feat_pending_send_sz set to indicate if
+  *    the consumer of the ring will signal when the ring
+  *    state transitions from being full to a state where
+  *    there is room for the producer to send the pending packet.
+  */
+ 
+ static bool hv_need_to_signal_on_read(u32 old_rd,
+ 					 struct hv_ring_buffer_info *rbi)
+ {
+ 	u32 prev_write_sz;
+ 	u32 cur_write_sz;
+ 	u32 r_size;
+ 	u32 write_loc = rbi->ring_buffer->write_index;
+ 	u32 read_loc = rbi->ring_buffer->read_index;
+ 	u32 pending_sz = rbi->ring_buffer->pending_send_sz;
+ 
+ 	/*
+ 	 * If the other end is not blocked on write don't bother.
+ 	 */
+ 	if (pending_sz == 0)
+ 		return false;
+ 
+ 	r_size = rbi->ring_datasize;
+ 	cur_write_sz = write_loc >= read_loc ? r_size - (write_loc - read_loc) :
+ 			read_loc - write_loc;
+ 
+ 	prev_write_sz = write_loc >= old_rd ? r_size - (write_loc - old_rd) :
+ 			old_rd - write_loc;
+ 
+ 
+ 	if ((prev_write_sz < pending_sz) && (cur_write_sz >= pending_sz))
+ 		return true;
+ 
+ 	return false;
+ }
  
  /*
   * hv_get_next_write_location()
***************
*** 239,257 ****
  	}
  }
  
- 
- /*
-  *
-  * hv_get_ringbuffer_interrupt_mask()
-  *
-  * Get the interrupt mask for the specified ring buffer
-  *
-  */
- u32 hv_get_ringbuffer_interrupt_mask(struct hv_ring_buffer_info *rbi)
- {
- 	return rbi->ring_buffer->interrupt_mask;
- }
- 
  /*
   *
   * hv_ringbuffer_init()
--- 339,344 ----
***************
*** 298,304 ****
   *
   */
  int hv_ringbuffer_write(struct hv_ring_buffer_info *outring_info,
! 		    struct scatterlist *sglist, u32 sgcount)
  {
  	int i = 0;
  	u32 bytes_avail_towrite;
--- 385,391 ----
   *
   */
  int hv_ringbuffer_write(struct hv_ring_buffer_info *outring_info,
! 		    struct scatterlist *sglist, u32 sgcount, bool *signal)
  {
  	int i = 0;
  	u32 bytes_avail_towrite;
***************
*** 307,312 ****
--- 394,400 ----
  
  	struct scatterlist *sg;
  	u32 next_write_location;
+ 	u32 old_write;
  	u64 prev_indices = 0;
  	unsigned long flags;
  
***************
*** 335,340 ****
--- 423,430 ----
  	/* Write to the ring buffer */
  	next_write_location = hv_get_next_write_location(outring_info);
  
+ 	old_write = next_write_location;
+ 
  	for_each_sg(sglist, sg, sgcount, i)
  	{
  		next_write_location = hv_copyto_ringbuffer(outring_info,
***************
*** 351,364 ****
  					     &prev_indices,
  					     sizeof(u64));
  
! 	/* Make sure we flush all writes before updating the writeIndex */
! 	smp_wmb();
  
  	/* Now, update the write location */
  	hv_set_next_write_location(outring_info, next_write_location);
  
  
  	spin_unlock_irqrestore(&outring_info->ring_lock, flags);
  	return 0;
  }
  
--- 441,456 ----
  					     &prev_indices,
  					     sizeof(u64));
  
! 	/* Issue a full memory barrier before updating the write index */
! 	smp_mb();
  
  	/* Now, update the write location */
  	hv_set_next_write_location(outring_info, next_write_location);
  
  
  	spin_unlock_irqrestore(&outring_info->ring_lock, flags);
+ 
+ 	*signal = hv_need_to_signal(old_write, outring_info);
  	return 0;
  }
  
***************
*** 414,426 ****
   *
   */
  int hv_ringbuffer_read(struct hv_ring_buffer_info *inring_info, void *buffer,
! 		   u32 buflen, u32 offset)
  {
  	u32 bytes_avail_towrite;
  	u32 bytes_avail_toread;
  	u32 next_read_location = 0;
  	u64 prev_indices = 0;
  	unsigned long flags;
  
  	if (buflen <= 0)
  		return -EINVAL;
--- 506,519 ----
   *
   */
  int hv_ringbuffer_read(struct hv_ring_buffer_info *inring_info, void *buffer,
! 		   u32 buflen, u32 offset, bool *signal)
  {
  	u32 bytes_avail_towrite;
  	u32 bytes_avail_toread;
  	u32 next_read_location = 0;
  	u64 prev_indices = 0;
  	unsigned long flags;
+ 	u32 old_read;
  
  	if (buflen <= 0)
  		return -EINVAL;
***************
*** 431,436 ****
--- 524,531 ----
  				&bytes_avail_toread,
  				&bytes_avail_towrite);
  
+ 	old_read = bytes_avail_toread;
+ 
  	/* Make sure there is something to read */
  	if (bytes_avail_toread < buflen) {
  		spin_unlock_irqrestore(&inring_info->ring_lock, flags);
***************
*** 461,465 ****
--- 556,562 ----
  
  	spin_unlock_irqrestore(&inring_info->ring_lock, flags);
  
+ 	*signal = hv_need_to_signal_on_read(old_read, inring_info);
+ 
  	return 0;
  }
diff -crN linux-3.8.6-gentoo/drivers/hv/vmbus_drv.c linux-3.8.6-gentoo-hyperv/drivers/hv/vmbus_drv.c
*** linux-3.8.6-gentoo/drivers/hv/vmbus_drv.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/hv/vmbus_drv.c	Sat Apr 13 02:24:31 2013
***************
*** 33,47 ****
  #include <acpi/acpi_bus.h>
  #include <linux/completion.h>
  #include <linux/hyperv.h>
  #include <asm/hyperv.h>
  #include <asm/hypervisor.h>
  #include "hyperv_vmbus.h"
  
  
  static struct acpi_device  *hv_acpi_dev;
  
  static struct tasklet_struct msg_dpc;
- static struct tasklet_struct event_dpc;
  static struct completion probe_event;
  static int irq;
  
--- 33,48 ----
  #include <acpi/acpi_bus.h>
  #include <linux/completion.h>
  #include <linux/hyperv.h>
+ #include <linux/kernel_stat.h>
  #include <asm/hyperv.h>
  #include <asm/hypervisor.h>
+ #include <asm/mshyperv.h>
  #include "hyperv_vmbus.h"
  
  
  static struct acpi_device  *hv_acpi_dev;
  
  static struct tasklet_struct msg_dpc;
  static struct completion probe_event;
  static int irq;
  
***************
*** 454,474 ****
  	union hv_synic_event_flags *event;
  	bool handled = false;
  
  	/*
  	 * Check for events before checking for messages. This is the order
  	 * in which events and messages are checked in Windows guests on
  	 * Hyper-V, and the Windows team suggested we do the same.
  	 */
  
! 	page_addr = hv_context.synic_event_page[cpu];
! 	event = (union hv_synic_event_flags *)page_addr + VMBUS_MESSAGE_SINT;
  
! 	/* Since we are a child, we only need to check bit 0 */
! 	if (sync_test_and_clear_bit(0, (unsigned long *) &event->flags32[0])) {
  		handled = true;
- 		tasklet_schedule(&event_dpc);
  	}
  
  	page_addr = hv_context.synic_message_page[cpu];
  	msg = (struct hv_message *)page_addr + VMBUS_MESSAGE_SINT;
  
--- 455,494 ----
  	union hv_synic_event_flags *event;
  	bool handled = false;
  
+ 	page_addr = hv_context.synic_event_page[cpu];
+ 	if (page_addr == NULL)
+ 		return IRQ_NONE;
+ 
+ 	event = (union hv_synic_event_flags *)page_addr +
+ 					 VMBUS_MESSAGE_SINT;
  	/*
  	 * Check for events before checking for messages. This is the order
  	 * in which events and messages are checked in Windows guests on
  	 * Hyper-V, and the Windows team suggested we do the same.
  	 */
  
! 	if ((vmbus_proto_version == VERSION_WS2008) ||
! 		(vmbus_proto_version == VERSION_WIN7)) {
  
! 		/* Since we are a child, we only need to check bit 0 */
! 		if (sync_test_and_clear_bit(0,
! 			(unsigned long *) &event->flags32[0])) {
! 			handled = true;
! 		}
! 	} else {
! 		/*
! 		 * Our host is win8 or above. The signaling mechanism
! 		 * has changed and we can directly look at the event page.
! 		 * If bit n is set then we have an interrup on the channel
! 		 * whose id is n.
! 		 */
  		handled = true;
  	}
  
+ 	if (handled)
+ 		tasklet_schedule(hv_context.event_dpc[cpu]);
+ 
+ 
  	page_addr = hv_context.synic_message_page[cpu];
  	msg = (struct hv_message *)page_addr + VMBUS_MESSAGE_SINT;
  
***************
*** 485,490 ****
--- 505,523 ----
  }
  
  /*
+  * vmbus interrupt flow handler:
+  * vmbus interrupts can concurrently occur on multiple CPUs and
+  * can be handled concurrently.
+  */
+ 
+ static void vmbus_flow_handler(unsigned int irq, struct irq_desc *desc)
+ {
+ 	kstat_incr_irqs_this_cpu(irq, desc);
+ 
+ 	desc->action->handler(irq, desc->action->dev_id);
+ }
+ 
+ /*
   * vmbus_bus_init -Main vmbus driver initialization routine.
   *
   * Here, we
***************
*** 496,502 ****
  static int vmbus_bus_init(int irq)
  {
  	int ret;
- 	unsigned int vector;
  
  	/* Hypervisor initialization...setup hypercall page..etc */
  	ret = hv_init();
--- 529,534 ----
***************
*** 506,512 ****
  	}
  
  	tasklet_init(&msg_dpc, vmbus_on_msg_dpc, 0);
- 	tasklet_init(&event_dpc, vmbus_on_event, 0);
  
  	ret = bus_register(&hv_bus);
  	if (ret)
--- 538,543 ----
***************
*** 520,532 ****
  		goto err_unregister;
  	}
  
! 	vector = IRQ0_VECTOR + irq;
  
  	/*
! 	 * Notify the hypervisor of our irq and
  	 * connect to the host.
  	 */
! 	on_each_cpu(hv_synic_init, (void *)&vector, 1);
  	ret = vmbus_connect();
  	if (ret)
  		goto err_irq;
--- 551,573 ----
  		goto err_unregister;
  	}
  
! 	/*
! 	 * Vmbus interrupts can be handled concurrently on
! 	 * different CPUs. Establish an appropriate interrupt flow
! 	 * handler that can support this model.
! 	 */
! 	irq_set_handler(irq, vmbus_flow_handler);
! 
! 	/*
! 	 * Register our interrupt handler.
! 	 */
! 	hv_register_vmbus_handler(irq, vmbus_isr);
  
  	/*
! 	 * Initialize the per-cpu interrupt state and
  	 * connect to the host.
  	 */
! 	on_each_cpu(hv_synic_init, NULL, 1);
  	ret = vmbus_connect();
  	if (ret)
  		goto err_irq;
***************
*** 575,582 ****
  
  	ret = driver_register(&hv_driver->driver);
  
- 	vmbus_request_offers();
- 
  	return ret;
  }
  EXPORT_SYMBOL_GPL(__vmbus_driver_register);
--- 616,621 ----
diff -crN linux-3.8.6-gentoo/drivers/net/hyperv/netvsc_drv.c linux-3.8.6-gentoo-hyperv/drivers/net/hyperv/netvsc_drv.c
*** linux-3.8.6-gentoo/drivers/net/hyperv/netvsc_drv.c	Tue Feb 19 08:58:34 2013
--- linux-3.8.6-gentoo-hyperv/drivers/net/hyperv/netvsc_drv.c	Sat Apr 13 02:24:34 2013
***************
*** 193,202 ****
  	for (i = 0; i < skb_shinfo(skb)->nr_frags; i++) {
  		const skb_frag_t *f = &skb_shinfo(skb)->frags[i];
  
! 		packet->page_buf[i+npg_data+1].pfn =
! 			page_to_pfn(skb_frag_page(f));
  		packet->page_buf[i+npg_data+1].offset = f->page_offset;
! 		packet->page_buf[i+npg_data+1].len = skb_frag_size(f);
  	}
  
  	/* Set the completion routine */
--- 193,201 ----
  	for (i = 0; i < skb_shinfo(skb)->nr_frags; i++) {
  		const skb_frag_t *f = &skb_shinfo(skb)->frags[i];
  
! 		packet->page_buf[i+npg_data+1].pfn = page_to_pfn(skb_frag_page(f));
  		packet->page_buf[i+npg_data+1].offset = f->page_offset;
! 		packet->page_buf[i+npg_data+1].len = f->size;
  	}
  
  	/* Set the completion routine */
***************
*** 498,505 ****
  
  static const struct hv_vmbus_device_id id_table[] = {
  	/* Network guid */
! 	{ VMBUS_DEVICE(0x63, 0x51, 0x61, 0xF8, 0x3E, 0xDF, 0xc5, 0x46,
! 		       0x91, 0x3F, 0xF2, 0xD2, 0xF9, 0x65, 0xED, 0x0E) },
  	{ },
  };
  
--- 497,503 ----
  
  static const struct hv_vmbus_device_id id_table[] = {
  	/* Network guid */
! 	{ HV_NIC_GUID, },
  	{ },
  };
  
